题目链接:​​http://acm.hdu.edu.cn/showproblem.php?pid=4849​


----------------------------------------------------------------------------------------------------------------------------------------------------------
欢迎光临天资小屋:http://user.qzone.qq.com/593830943/main
----------------------------------------------------------------------------------------------------------------------------------------------------------




Problem Description



Doge, tired of being a popular image on internet, is considering moving to another city for a new way of life.
In his country there are N (2 ≤N≤ 1000) cities labeled 0 . . . N - 1. He is currently in city 0. Meanwhile, for each pair of cities, there exists a road connecting them, costing Ci,j (a positive integer) for traveling from city i to city j. Please note that Ci,j may not equal to Cj,i for any given i ≠ j.
Doge is carefully examining the cities: in fact he will divide cities (his current city 0 is NOT included) into M (2 ≤ M ≤ 106) categories as follow: If the minimal cost from his current city (labeled 0) to the city i is Di, city i belongs to category numbered Di mod M.Doge wants to know the “minimal” category (a category with minimal number) which contains at least one city.
For example, for a country with 4 cities (labeled 0 . . . 3, note that city 0 is not considered), Doge wants to divide them into 3 categories. Suppose category 0 contains no city, category 1 contains city 2 and 3, while category 2 contains city 1, Doge consider category 1 as the minimal one.
Could you please help Doge solve this problem?


Note:

Ci,j is generated in the following way:
Given integers X0, X1, Y0, Y1, (1 ≤ X0, X1, Y0, Y1≤ 1234567), for k ≥ 2 we have
Xk = (12345 + Xk-1 * 23456 + Xk-2 * 34567 + Xk-1 * Xk-2 * 45678) mod 5837501
Yk = (56789 + Yk-1 * 67890 + Yk-2 * 78901 + Yk-1 * Yk-2 * 89012) mod 9860381
The for k ≥ 0 we have

Zk = (Xk * 90123 + Yk ) mod 8475871 + 1

Finally for 0 ≤ i, j ≤ N - 1 we have

Ci,j = Zi*n+j for i ≠ j
Ci,j = 0 for i = j


 


Input



There are several test cases. Please process till EOF.
For each test case, there is only one line containing 6 integers N,M,X0,X1,Y0,Y1.See the description for more details.


 


Output



For each test case, output a single line containing a single integer: the number of minimal category.


 


Sample Input



3 10 1 2 3 4
4 20 2 3 4 5


Sample Output



1
10

For the first test case, we have


0 1 2 3 4 5 6 7 8
X 1 2 185180 788997 1483212 4659423 4123738 2178800 219267
Y 3 4 1633196 7845564 2071599 4562697 3523912 317737 1167849
Z 90127 180251 1620338 2064506 625135 5664774 5647950 8282552 4912390

the cost matrix C is
 0 180251 1620338
 2064506 0 5664774 
5647950 8282552 0

So the minimal cost from city 0 to city 1 is 180251, while the distance to city 2 is 1620338. Given M = 10, city 1 and city 2 belong to category 1 and 8 respectively. Since only category 1 and 8 contain at least one city, the minimal one of them, category 1, is the desired answer to Doge’s question.


题意:找从起点0開始到n-1各点的最短距离!注意要先模m后再找最短距离,也就是说存在原路径并非最短距离,可是模上m后就是最短的距离的情况!


dijkstra代码例如以下:

#include <cstdio>
#include <iostream>
#include <algorithm>
#define MAX 1017
#define INF 1000000000
using namespace std;
__int64 c[MAX][MAX];
__int64 x[MAX*MAX], y[MAX*MAX], z[MAX*MAX];

void dijkstra (__int64 mat[][MAX],int n, int s,int f)
{//s为起点。 f:为终点
__int64 dis[MAX];//记录到不论什么点的最短距离
__int64 mark[MAX];//记录被选中的结点
int i,j,k = 0;
for(i = 0 ; i < n ; i++)//初始化全部结点。每一个结点都没有被选中
mark[i] = 0;
for(i = 0 ; i < n ; i++)//将每一个结点到start结点weight记录为当前distance
{
dis[i] = mat[s][i];
//path[i] = s;
}
mark[s] = 1;//start结点被选中
//path[s] = 0;
dis[s] = 0;//将start结点的的距离设置为0
__int64 min ;//设置最短的距离。
for(i = 1 ; i < n; i++)
{
min = INF;
for(j = 0 ; j < n;j++)
{
if(mark[j] == 0 && dis[j] < min)//未被选中的结点中。距离最短的被选中
{
min = dis[j] ;
k = j;
}
}
mark[k] = 1;//标记为被选中
for(j = 0 ; j < n ; j++)
{
if( mark[j] == 0 && (dis[j] > (dis[k] + mat[k][j])))//改动剩余结点的最短距离
{
dis[j] = dis[k] + mat[k][j];
}
}
}
}
int main()
{
int n, m;
int i, j;

while(~scanf("%d%d",&n,&m))
{
scanf("%I64d%I64d%I64d%I64d",&x[0],&x[1],&y[0],&y[1]);
for(i = 0; i < 2; i++)
{
z[i] = (x[i]*90123+y[i])%8475871+1;
}
for(i = 2; i <= n*n; i++)
{
x[i]=(12345+x[i-1]*23456+x[i-2]*34567+x[i-1]*x[i-2]*45678)%5837501;
y[i]=(56789+y[i-1]*67890+y[i-2]*78901+y[i-1]*y[i-2]*89012)%9860381;
z[i]=(x[i]*90123+y[i])%8475871+1;
}
for(i = 0; i < n; i++)
{
for(j = 0; j < n; j++)
{
if(i == j)
c[i][j] = 0;
else
c[i][j] = z[i*n+j];
}
}
__int64 mmax = INF, ans;
dijkstra(c,n,0,n-1);
for(i = 1; i < n; i++)
{
ans = dis[i];
if(ans == 0)
continue;
ans%=m;
if(mmax > ans)
{
mmax = ans;
}
}
printf("%I64d\n",mmax);
}
return 0;
}